<template>
  <div class="content">
    <div class="grid justify-center items-center pt-6">
      <div class="grid justify-center items-center">
        <h1 class="text-2xl mb-4">VIN Search</h1>
        <form class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4">
          <input
            v-model="vin"
            type="text"
            placeholder="Enter VIN"
            class="shadow appearance-none border rounded w-full py-2 px-3 text-gray-700 leading-tight focus:outline-none focus:shadow-outline"
          />
          <button
            type="button"
            class="px-4 py-2 mt-5 bg-blue-500 text-white rounded"
            @click="searchVIN"
          >
            Search
          </button>

          <div
            v-show="errorVIN"
            class="bg-red-100 border border-red-400 text-red-700 px-4 py-3 mt-5 rounded relative"
            role="alert"
          >
            <strong class="font-bold">Error! </strong>
            <span
              class="block sm:inline"
              v-for="error in msjerrorVIN"
              :key="error"
              v-text="error"
            >
            </span>
          </div>
        </form>
      </div>

      <div class="grid justify-center items-center w-auto">
        <div v-if="result" class="mt-4">
          <h2 class="text-lg mb-2 shadow-md rounded">
            Result Decode VIN for {{ this.resultVIN }}
          </h2>
          <!-- Resultadoo de Decode VIN en grid -->
          <div class="w-auto justify-center items-center pt-6 shadow p-5">
            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Year
                </label>
                {{ specification.year }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Maker
                </label>
                {{ specification.make }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Model
                </label>
                {{ specification.model }}
              </div>
            </div>
            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Trim Level
                </label>
                {{ specification.year }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Engine
                </label>
                {{ specification.engine }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Style
                </label>
                {{ specification.style }}
              </div>
            </div>

            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Made In
                </label>
                {{ specification.made_in }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Steering Type
                </label>
                {{ specification.steering_type }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Antibrake system
                </label>
                {{ specification.anti_brake_system }}
              </div>
            </div>

            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Tank Size
                </label>
                {{ specification.tank_size }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Overall Height
                </label>
                {{ specification.overall_height }}
              </div>
              <div class="w-full md:w-1/3 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Overall Length
                </label>
                {{ specification.overall_length }}
              </div>
            </div>

            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Overall Width
                </label>
                {{ specification.overall_width }}
              </div>
              <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  Standard Seating
                </label>
                {{ specification.standard_seating }}
              </div>
            </div>
            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Highway Mileage
                </label>
                {{ specification.highway_mileage }}
              </div>
              <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-last-name"
                >
                  City Mileage
                </label>
                {{ specification.city_mileage }}
              </div>
            </div>
            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Optional seating
                </label>
                {{ specification.optional_seating }}
              </div>
            </div>
          </div>
        </div>
      </div>

      <div class="grid justify-center items-center w-auto">
        <div v-if="salvage" class="mt-4">
          <h2 class="text-lg mb-2 shadow-md rounded">
            Result for Salvage Check
          </h2>

          <!-- Resultadoo de Decode VIN en grid -->
          <div
            class="w-auto justify-center items-center pt-6 shadow-md p-4"
            v-if="is_salvage"
          >
            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2 shadow-md"
                  for="grid-first-name"
                >
                  Title
                </label>
                {{ info.vehicle_title }}
              </div>
              <div class="w-full md:w-1/2 px-3 pt-5 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
                  for="grid-last-name"
                >
                  Mileage
                </label>
                {{ info.mileage }}
              </div>
              <div class="w-full md:w-1/2 px-3 pt-5 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
                  for="grid-last-name"
                >
                  Lost Type
                </label>
                {{ info.lost_type }}
              </div>
            </div>
            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
                  for="grid-first-name"
                >
                  Primary Damage
                </label>
                {{ info.primary_damage }}
              </div>
              <div class="w-full md:w-1/2 px-3 mb-6 md:mb-0">
                <label
                  class="block uppercase tracking-wide text-gray-700 text-xs font-bold mb-2"
                  for="grid-last-name"
                >
                  Secondary Damage
                </label>
                {{ info.secondary_damage }}
              </div>
            </div>
          </div>
          <div class="w-auto justify-center items-center pt-6" v-else>
            <div class="flex flex-wrap -mx-3 mb-6">
              <div class="w-full px-3 mb-6 md:mb-0">
                <div
                  class="bg-teal-100 border-t-4 border-teal-500 rounded-b text-teal-900 px-4 py-3 shadow-md"
                  role="alert"
                >
                  <div class="flex">
                    <div class="py-1">
                      <svg
                        class="fill-current h-6 w-6 text-teal-500 mr-4"
                        xmlns="http://www.w3.org/2000/svg"
                        viewBox="0 0 20 20"
                      >
                        <path
                          d="M2.93 17.07A10 10 0 1 1 17.07 2.93 10 10 0 0 1 2.93 17.07zm12.73-1.41A8 8 0 1 0 4.34 4.34a8 8 0 0 0 11.32 11.32zM9 11V9h2v6H9v-4zm0-6h2v2H9V5z"
                        />
                      </svg>
                    </div>
                    <div class="py-1">
                      <p class="font-bold">
                        No se encontraron registros para este VIN
                      </p>
                      <p class="text-sm">.</p>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";

export default {
  data() {
    return {
      vin: "",
      result: 0,
      salvage: 0,
      is_salvage: 0,
      errorVIN: 0,
      msjerrorVIN: [],
      resultVIN: "",
      specification: [],
      info: [],
    };
  },
  methods: {
    searchVIN() {
      if (this.validateVIN()) {
        return;
      }

      const headers = {
        Authorization: "Bearer " + this.$store.getters.getToken,
      };

      axios
        .post(
          process.env.VUE_APP_API_URL + "v1/search/decode",
          {
            vin: this.vin,
          },
          { headers }
        )
        .then((res) => {
          if (res.data.status == "Success") {
            this.result = 1;
            this.resultVIN = res.data.searchVIN.data.vin;
            this.specification = res.data.searchVIN.data.specification;
            this.salvageVIN();
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    salvageVIN() {
      if (this.validateVIN()) {
        return;
      }

      const headers = {
        Authorization: "Bearer " + this.$store.getters.getToken,
      };

      axios
        .post(
          process.env.VUE_APP_API_URL + "v1/search/salvage",
          {
            vin: this.vin,
          },
          { headers }
        )
        .then((res) => {
          if (res.data.status == "Success") {
            this.salvage = 1;
            this.resultVIN = this.vin;
            this.is_salvage = res.data.searchVIN.data.is_salvage;
            this.info = res.data.searchVIN.data.info;
          }
        })
        .catch((error) => {
          console.error(error);
        });
    },
    validateVIN() {
      this.errorVIN = 0;
      this.msjerrorVIN = [];

      if (this.vin == "") {
        this.msjerrorVIN.push("El campo VIN no puede ser vacio");
      } else {
        if (this.vin.length != 17) {
          this.msjerrorVIN.push("El campo VIN debe contener 17 caracteres");
        }
      }

      if (this.msjerrorVIN.length) this.errorVIN = 1;

      return this.errorVIN;
    },
  },
  mounted() {
    if (this.$store.getters.getToken == null) {
      this.$router.push("/");
    }
  },
};
</script>

<style></style>
